#include "Parameters.h"

#include "OneStepReaction.h"
#include "BranchingReaction.h"
#include "Chemkin.h"

//! Construction the appropriate Reactions class
int Parameters::
buildReactions()
{

  if(  dbase.get<aString >("reactionName")=="one step" )
  {
     dbase.get<int >("numberOfSpecies")=1;
     dbase.get<Reactions* >("reactions")=new OneStepReaction;
  }
  else if(  dbase.get<aString >("reactionName")=="branching" )
  {
     dbase.get<int >("numberOfSpecies")=2;
     dbase.get<Reactions* >("reactions")=new BranchingReaction;
  }
  else if(  dbase.get<aString >("reactionName")=="passive scalar advection" )
  {
     dbase.get<int >("numberOfSpecies")=1;
     dbase.get<bool >("advectPassiveScalar")=true;
  }
  else if(  dbase.get<aString >("reactionName")=="one equation mixture fraction" )
  {
     dbase.get<int >("numberOfSpecies")=1;
  }
  else if(  dbase.get<aString >("reactionName")=="two equation mixture fraction and extent of reaction" )
  {
     dbase.get<int >("numberOfSpecies")=2;
  }
  else if(  dbase.get<aString >("reactionName")=="ignition and growth" )
  {
    // lambda
     dbase.get<int >("numberOfSpecies")=1;
  }
  else if(  dbase.get<aString >("reactionName")=="ignition and growth desensitization" )
  {
     dbase.get<int >("numberOfSpecies")=2;
  }
  else
  {
    cout << "++++++buildReactions:: try to open Chemkin file=[" <<  dbase.get<aString >("reactionName")+".chem.bin" << "]\n";
     dbase.get<Reactions* >("reactions")=new Chemkin( dbase.get<aString >("reactionName")+".chem.bin");      // delete this!
     dbase.get<int >("numberOfSpecies")= dbase.get<Reactions* >("reactions")->numberOfSpecies();
  }

  return 0;
}
