#include "Overture.h"

#ifndef PROBE_INFO_H
#define PROBE_INFO_H "ProbeInfo.h"

class ProbeInfo
{
public:
enum ProbeTypesEnum
{
  probeAtGridPoint,  // probe is located at a grid point
  probeAtLocation,   // probe is located at a fixed position
  probeBoundingBox   // save probe data on the boundary of a box (for subsequent sub-domain computations)
};

ProbeInfo();
~ProbeInfo();


// define the properties of the probe: 
int update( CompositeGrid & cg, GenericGraphicsInterface & gi );

// data -- make public for now
ProbeTypesEnum probeType;
int grid, iv[3];  // holds grid pt for probeAtGridPoint
real xv[3];         // holds coordinates for probeAtLocation

FILE *file;
aString fileName;

// Data for the bounding box probe file
int boundingBoxGrid, boundingBox[6], numberOfLayers;  // for the probeBoundingBox
GenericDataBase *pdb;
int numberOfTimes;
RealArray *times;  // solutions are saved at these times

};

#endif
