*
*   A falling sphere in a rectangular channel
* 
*
$solver = "choose best iterative solver";
** $solver = "multigrid";
$tolerance = "1.e-7";
$nu =.1;
* $hybrid = "use hybrid grid for surface integrals";
$hybrid = "do not use hybrid grid for surface integrals";
$tFinal=3.;
$g = -981.; # cm/s^2   -9.81 acceleration due to gravity standard value: 9.80665 m/s^2.
$vIn = 2.;
$tPrint=.05;
*
* $gridName = "drop3d.hdf"; $show="drop3d.show"; $nu=.05; 
$gridName = "drop3d1.hdf"; $show="drop3d.show"; $vIn=7.5; $tFinal=2.; $nu=.05; $tPrint=.2; $tolerance = "1.e-6";
* $gridName = "drop3d2.hdf"; $show="drop3d2.show"; $vIn=7.5; $tFinal=2.; $nu=.025; $tolerance = "1.e-6";
* $gridName = "drop3d2.hdf"; $show="drop3d2Restart.show"; $vIn=7.5; $tFinal=2.; $tPrint=.01; $nu=.025; $tolerance = "1.e-6";
*
*
  $gridName
  incompressible Navier Stokes
  exit
*
  show file options
  * un-comment the next two lines to save a show file
   open
      $show
    frequency to flush
      1
  exit  
  turn off twilight zone
*
  recompute dt every 10 *  1 * 2 * 5 * 10 * 1 
*
****
  turn on moving grids
*   detect collisions 1
****
  $pi =3.141592653;
  * $radius=.35;
  $radius=.25;
  $density = 1.1;  $volume = 4./3.*$pi*$radius**3; $mass=$volume*$density;
  specify grids to move
      $hybrid
      rigid body
        density
          $density
        mass
           $mass
         moments of inertia
           $momentOfInertia=2./5.*$mass*$radius**2;
           $momentOfInertia $momentOfInertia $momentOfInertia
           * 1. 1. 1. 
         initial centre of mass
            0. 0. 0.   -.25 -.25 -.75
         * initial velocity
         done
 	sphere1-north-pole
	sphere1-south-pole
      done
  done
**********
*
  pde parameters
    nu
      $nu 
*   -- specify the fluid density
   fluid density
     1.
*  turn on gravity
    gravity
       0. $g 0.
   OBPDE:second-order artificial diffusion 1
   OBPDE:ad21,ad22  2,2 
   OBPDE:expect inflow at outflow
   done
  boundary conditions
    all=noSlipWall, uniform(v=$vIn)
    channel(0,1)=inflowWithVelocityGiven,  uniform(p=1,v=$vIn)
    channel(1,1)=outflow , pressure(1.*p+0.0*p.n=0.)
    done
*
*  implicit
*  choose grids for implicit
*    all=implicit
*  done
*
  initial conditions
    uniform flow
     p=1., v=$vIn
*** ---
*   read from a show file
*    drop3d2.show
*      -1 6  -1
  exit
*
project initial conditions
*
  final time $tFinal 
  times to plot $tPrint
*
  plot and always wait
**  no plotting
*
*  initial conditions
*     read from a show file
*      twoDropNew2.show
*       24 48  -1 35 -1 1 4 -1 10 18  -1
*  exit
*
***************************************************
   pressure solver options
     $solver 
     relative tolerance
       $tolerance
     absolute tolerance
       $tolerance
*mg      multigrid parameters
*mg      *  alternating
*mg      * cycles: 1=V, 2=W
*mg      * -- coarse grid solver parameters ---
*mg        Oges parameters
*mg        fillin ratio
*mg          55
*mg        choose best iterative solver
*mg        exit
*mg      * ---
*mg      number of cycles
*mg        2
*mg      residual tolerance
*mg         $tolerance
*mg      error tolerance
*mg         $tolerance
*mg      maximum number of iterations
*mg        50
*mg      maximum number of interpolation iterations
*mg         8 30 10
*mg *      maximum number of levels
*mg *        5 4 3 2
*mg *      maximum number of extra levels
*mg *        4 3 2 1
*mg      debug
*mg        1 3 7 3 1 0 3
*mg      exit
    exit
****************************************************
*   * use GMRES to solve the pressure equation
*   pressure solver options
*      choose best iterative solver
*      * these tolerances are chosen for PETSc
*      relative tolerance
*        1.e-4
*      absolute tolerance
*        1.e-6
*     exit
*
*  debug
*     63
  continue
*
* ----------- plot solution of sphere surface
    contour
      plot contours on grid boundaries
      (1,0,2) = (transform[grid=1],side,axis) (off)
      (2,0,2) = (transform[grid=2],side,axis) (off)
      exit
*      set view:0 0 0 0 1 0.827404 -0.160413 0.538211 -0.114096 0.89034 0.440768 -0.549896 -0.426101 0.718368
      exit
*-----------------------
*


movie mode
finish





   grid
*      raise the grid by this amount (2D) 1
*      raise the grid by this amount (2D) 2
    toggle shaded surfaces 0 0
    exit this menu
    plot:v

* output resolution
*  512
*movie and save
*  twoDrop
