#
# Here are options for Oges. This file can be included in cg command scripts
#
# $ogesSolver :  "yale", "use best iterative solver", ...
# $ogesCmd : define any extra Oges commands here
# $ogesRtol   :  relative tolerance
# $ogesAtol   :  absolute tolerance
# $ogesEtol   :  error tolerance (for MG)
# $ogesMaxIterations   :  maximum number of iterations.
# $ogesPc : preconditioner: ilu, lu, 
# $ogesIluLevels : number of levels for ILU preconditioner
# $ogesDebug : debug parameter
#    -- multigrid: 
# $ogmgCmd : define any extra Ogmg commands here 
# $ogmgCycle : multigrid cycle 1=V, 2=W, .. #
# $ogmgDebug :  debug parameter for Ogmg
# $ogmgOpav : operator averaging option: 0=none, 1=all, 2=Cartesian grids
# $ogmgSsr : 1=show smoothing rates
# $ogmgCoarseGridSolver : multigrid coarse grid solver
# $ogmgRtolcg :  relative tolerance for multigrid Coarse Grid solve
# $ogmgAtolcg :  absolute tolerance for multigrid Coarse Grid solve
# $ogmgDebugcg : debug for coarse grid solvers
# -- defaults --
if( $ogesSolver eq "" ){ $ogesSolver="yale"; } #
if( $ogesCmd eq "" ){ $ogesCmd="#"; } #
if( $ogesRtol eq "" ){ $ogesRtol=1.e-6; } #
if( $ogesAtol eq "" ){ $ogesAtol=1.e-8; } #
if( $ogesEtol eq "" ){ $ogesEtol=1.e-3; } #
if( $ogesDtol eq "" ){ $ogesDtol=1.e5; } #
if( $ogesMaxIterations eq "" ){ $ogesMaxIterations=-1; } #
if( $ogesPc eq "ilu" ){ $ogesPc = "incomplete LU preconditioner"; }elsif( $ogesPc eq "lu" ){ $ogesPc = "lu preconditioner"; }else{ $ogesPc="#"; }
if( $ogesIluLevels eq "" ){ $ogesIluLevels=3; } #
if( $ogesDebug eq "" ){ $ogesDebug=0; } #
#
if( $ogmgCycle eq "" ){ $ogmgCycle=1; } #
if( $ogmgCmd eq "" ){ $ogmgCmd="#"; } #
if( $ogmgDebug eq "" ){ $ogmgDebug=0; } #
if( $ogmgRtolcg eq "" ){ $ogmgRtolcg=1.e-3; } #
if( $ogmgAtolcg eq "" ){ $ogmgAtolcg=1.e-6; } #
if( $ogmgOpav eq "" ){ $ogmgOpav =1; } #
if( $ogmgOpav eq "0" ){ $ogmgOpav = "do not average coarse grid equations"; }\
  elsif( $ogmgOpav eq "2" ){ $ogmgOpav ="do not average coarse curvilinear grid equations"; }else{ $ogmgOpav = "#"; }
if( $ogmgSsr eq 1 ){ $ogmgSsr="show smoothing rates"; }else{ $ogmgSsr="#"; }
if( $ogmgCoarseGridSolver eq "" ){ $ogmgCoarseGridSolver="choose best iterative solver"; }
if( $ogmgCoarseGridSolver eq "best" ){ $ogmgCoarseGridSolver="choose best iterative solver"; }
if( $ogmgDebugcg eq "" ){ $ogmgDebugcg=0; } #
if( $ogmgAutoChoose eq "" ){ $ogmgAutoChoose=1; } #
#
  $ogesSolver
 # these tolerances are chosen for PETSc
  number of incomplete LU levels
    $ogesIluLevels
  relative tolerance
    $ogesRtol
  absolute tolerance
    $ogesAtol
  maximum allowable increase in the residual
    $ogesDtol
  maximum number of iterations
    $ogesMaxIterations
  # preconditionner:
    $ogesPc
  debug
    $ogesDebug
  # Perform any user supplied Oges commands: 
  $ogesCmd
  # --- start of multigrid parameters ---
  multigrid parameters
   # -- automatically choose MG parameters: (fix me)
   if( $ogmgAutoChoose eq 1 ){ $cmd="choose good parameters"; }else{ $cmd="#"; }
   $cmd
   # --- now over-ride automatically chosen parameters ---
   # --- for parallel use: 
   use new red-black smoother
   # -- trouble with RB-jacobi (works in ogmg)
   #    red black jacobi
   # show smoothing rates? : 
   $ogmgSsr
   # cycles: 1=V, 2=W
   number of cycles
     $ogmgCycle
   residual tolerance $ogesRtol
   absolute tolerance $ogesAtol
   error tolerance $ogesEtol
   $ogmgOpav
   # turn off using local omega for line solves and variable coefficients - trouble in parallel *fix me*
   do not use locally optimal line omega
   # -- "direct" solver on coarse grid: 
   Oges parameters
    $ogmgCoarseGridSolver
     relative tolerance
       $ogmgRtolcg
     absolute tolerance
       $ogmgAtolcg
     debug
      $ogmgDebugcg
     $ogesCmd
    exit
   maximum number of interpolation iterations
        3
   #      maximum number of levels
   #        5 4 3 2
   #      maximum number of extra levels
   #        4 3 2 1
    debug
     $ogmgDebug
   $ogmgCmd
  exit
  # --- end of multigrid parameters ---

