* file is included by other command files to define a Cgins domain
*
* The following parameters should be set before including this file: 
*   $domainName : name of the domain to assign
*   $solverName : name given to the domain (e.g. "fluid")
*   $tz, $degreeSpace, $degreeTime : 
*   $ts
*   $dtMax
*   $nu, $kThermal, $gravity, $thermalExpansivity, $ktc
*   $ic : specify initial condition commands
*   $bc : specify boundary condition commands
*   $gravity : 
*   $solver, $atolp, $rtolp
*   $pdebug 
*   $axisymmetric : if non-null turn on the axisymmetric flow option
*   $implicitFactor : for implicit time-stepping: .5=CN, 1.=BE, 0.=FE
*   $projectInitialConditions : 
*   $extraCmds : extra commands
* 
* ------- start new domain ----------
if( $thermalExpansivity eq "" ){ $thermalExpansivity=1.; }
if( $adcBoussinesq eq "" ){ $adcBoussinesq=0.; }
if( $dtMax eq "" ){ $dtMax=1.e20; }
if( $rtolp eq "" ){ $rtolp=1.e-5; }
if( $atolp eq "" ){ $atolp=1.e-7; }
if( $rtoli eq "" ){ $rtoli=1.e-5; }
if( $atoli eq "" ){ $atoli=1.e-7; }
if( $pdebug eq "" ){ $pdebug=0; }
if( $idebug eq "" ){ $idebug=0; }
if( $tz eq "" ){ $tz="turn off twilight zone"; }
if( $fx eq "" ){ $fx=1.; }
if( $fy eq "" ){ $fy=1.; }
if( $fz eq "" ){ $fz=1.; }
if( $ft eq "" ){ $ft=1.; }
if( $u0 eq "" ){ $u0=0.; }
if( $T0 eq "" ){ $T0=0.; }
if( $cdv eq "" ){ $cdv=1.; }
if( $cDt eq "" ){ $cDt=.25; }  # the div damping is at most cDt/dt
if( $ad2 eq "" ){ $ad2=0; }
if( $ad21 eq "" ){ $ad21=1.; }
if( $ad22 eq "" ){ $ad22=1.; }
if( $implicitFactor eq "" ){ $implicitFactor=.5; }
if( $implicitVariation eq "" ){ $implicitVariation = "implicitViscous"; }
if( $projectInitialConditions eq "" ){ $projectInitialConditions="*";} 
if( $extraCmds eq "" ){ $extraCmds="*"; }
* 
setup $domainName
 set solver Cgins
 solver name $solverName
 solver parameters
* 
  incompressible Navier Stokes
  Boussinesq model
*   define real parameter kappa $kThermal
  define real parameter thermalExpansivity $thermalExpansivity
  define real parameter adcBoussinesq $adcBoussinesq 
  continue
* 
  $tz
  degree in space $degreeSpace
  degree in time $degreeTime
  OBTZ:frequencies (x,y,z,t) $fx, $fy, $fz, $ft
* 
  $ts
**  useNewImplicitMethod
  $implicitVariation
  implicit factor $implicitFactor 
  refactor frequency $refactorFrequency
* 
  dtMax $dtMax
  debug $debug 
*
  pde parameters
    nu  $nu
    kThermal $kThermal
    thermal conductivity $ktc
    gravity
      $gravity
   done
* 
    OBPDE:second-order artificial diffusion $ad2
    OBPDE:ad21,ad22  $ad21, $ad22
    OBPDE:divergence damping  $cdv 
    OBPDE:cDt div damping $cDt
* 
$setAxi = $axisymmetric ? "turn on axisymmetric flow" : "*";
$setAxi
$setAxi="";
  if( $commands eq "" ){ $commands_ins="debug $debug";}else{$commands_ins=$commands; } #
  $commands_ins
  $commands_ins=""; 
* 
    maximum number of iterations for implicit interpolation
      10
  pressure solver options
     $solver
     * yale
     * these tolerances are chosen for PETSc
     relative tolerance
      $rtolp
     absolute tolerance
      $atolp
     debug 
       $pdebug
    exit
* 
  implicit time step solver options
     $solver
     * these tolerances are chosen for PETSc
     relative tolerance
      $rtoli
     absolute tolerance
      $atoli
     debug 
       $idebug
    exit
* 
  boundary conditions
   $bc 
  done
* 
  initial conditions
  if( $tz eq "turn off twilight zone" && $ic eq "" ){ $ic="uniform flow\n" . "p=1., u=$u0, T=$T0"; }elsif( $ic eq "" ){ $ic="*";}
    $ic
  continue
  $projectInitialConditions
  $extraCmds
* 
  continue
done
* kkc 080328 reset commands so that it can be used in subsequent includes (commands was created in this header
*#$commands="";
